/*
 File: la_expr_src.h
 Date and Time: Fri Jan 30 18:55:13 2015 
*/
#ifndef __la_expr_src_h__
#define __la_expr_src_h__ 1
#include "yacco2.h"
#include "yacco2_T_enumeration.h"
#include "yacco2_k_symbols.h"
#include "yacco2_err_symbols.h"
#include "yacco2_terminals.h"
#include "yacco2_characters.h"

#include "c_string.h"
#include "identifier.h"
#include "c_literal.h"
#include "lint_balls.h"
#include "o2_code_end.h"
#include "la_lrk_T.h"
#include "yacco2_stbl.h"
using namespace NS_yacco2_terminals;
  
extern yacco2::Thread_entry ITH_la_expr_src;

extern yacco2::State S1_Cla_expr_src;
namespace NS_la_expr_src {
yacco2::THR _YACCO2_CALL_TYPE
TH_la_expr_src(yacco2::Parser* Caller);// called thread
yacco2::THR_result _YACCO2_CALL_TYPE
PROC_TH_la_expr_src(yacco2::Parser* Caller);// called thread's twin the procedure
using namespace NS_yacco2_T_enum;// enumerate
using namespace yacco2;
struct fsm_rules_reuse_table_type{
 fsm_rules_reuse_table_type();
 int no_rules_entries_;
 Per_rule_s_reuse_table* per_rule_s_table_[5];
};
class Cla_expr_src: public yacco2::CAbs_fsm {
 public:
  enum rules_and_subrules{
   start_of_rule_list = NS_yacco2_T_enum::T_Enum::sum_total_T
   ,R_Rla_expr_src_ = 569//start_of_rule_list + 0
    ,rhs1_Rla_expr_src_ = 1
   ,R_Rtoks_ = 570//start_of_rule_list + 2
    ,rhs1_Rtoks_ = 2
    ,rhs2_Rtoks_ = 3
   ,R_Rtok_ = 571//start_of_rule_list + 4
    ,rhs1_Rtok_ = 4
    ,rhs2_Rtok_ = 5
    ,rhs3_Rtok_ = 6
    ,rhs4_Rtok_ = 7
    ,rhs5_Rtok_ = 8
    ,rhs6_Rtok_ = 9
    ,rhs7_Rtok_ = 10
    ,rhs8_Rtok_ = 11
    ,rhs9_Rtok_ = 12
    ,rhs10_Rtok_ = 13
    ,rhs11_Rtok_ = 14
    ,rhs12_Rtok_ = 15
   ,R_Rlint_ = 572//start_of_rule_list + 6
    ,rhs1_Rlint_ = 16
    ,rhs2_Rlint_ = 17
   ,R_Rla_minus_ = 573//start_of_rule_list + 8
    ,rhs1_Rla_minus_ = 18
    ,rhs2_Rla_minus_ = 19
  };
  //no of la sets = 2
  //no of states = 19
  Cla_expr_src();
  ~Cla_expr_src();
  void op();
  bool failed();
  void reduce_rhs_of_rule
      (yacco2::UINT Sub_rule_no,yacco2::Rule_s_reuse_entry** Recycled_rule);
  fsm_rules_reuse_table_type fsm_rules_reuse_table;
  static int rhs_to_rules_mapping_[20];
  
    public: 
    T_la_expr_src* exp_;
  
 };
struct Rla_expr_src;
struct Rtoks;
struct Rtok;
struct Rlint;
struct Rla_minus;
struct Rla_expr_src:public yacco2::CAbs_lr1_sym {
  Rla_expr_src(yacco2::Parser* P);
  public:
};

struct Rtoks:public yacco2::CAbs_lr1_sym {
  Rtoks(yacco2::Parser* P);
  public:
};

struct Rtok:public yacco2::CAbs_lr1_sym {
  Rtok(yacco2::Parser* P);
  public:
  void sr1();
  void sr2();
  void sr3();
  void sr4();
  void sr5();
  void sr6();
  void sr7();
  void sr8();
  void sr9();
  void sr10();
  void sr11();
};

struct Rlint:public yacco2::CAbs_lr1_sym {
  Rlint(yacco2::Parser* P);
  public:
};

struct Rla_minus:public yacco2::CAbs_lr1_sym {
  Rla_minus(yacco2::Parser* P);
  public:
};

} // end of namespace

#endif
